/*
******************************************************************************

   Fallback stubs BLT implementation - API functions.

   Copyright (C) 2001	Brian S. Julin [bri@tull.umassp.edu]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include "stubsblt.h"

ggiBlt_t BLT_stubs_tie(ggiGA_resource_handle *handles, int numhandles)
{
	ggiBlt_t res;
	int i;

	if (handles[0] == NULL) return NULL;

	res = calloc(1, sizeof(struct ggiBlt));
	if (res == NULL) goto out;
	res->handles = calloc(numhandles, sizeof(ggiGA_resource_handle));
	if (res->handles == NULL) goto err1;
	res->numhandles = numhandles;
	res->vis = ggiGAGetVisual(handles[0]);

	memcpy(res->handles, handles, 
	       numhandles * sizeof(ggiGA_resource_handle));
	for (i = 0; i < numhandles; i++) {
		/* TODO: find the right carb */
		if (ggiGAIsCarb(handles[i])) res->def_carb_h = handles[i];
	}

	res->trans = calloc(sizeof(struct batchop), 1);
	if (res->trans == NULL) goto err2;

	res->trans->numparms = BLT_STUBS_NUMPARMS;
	res->trans->match = BLT_stubs_bo_match;
	res->trans->go = NULL;
	res->trans->parms = 
		malloc(sizeof(struct batchparm) * BLT_STUBS_NUMPARMS);
	if (res->trans->parms == NULL) goto err3;
	memcpy(res->trans->parms, BLT_stubs_bp, 
	       sizeof(struct batchparm) * BLT_STUBS_NUMPARMS);
	bo_set_in_idx(res->trans, 0);
	bo_set_out_idx(res->trans, 0);

 out:
	return(res);
 err3:
	free(res->trans);
 err2:
	free(res->handles);
 err1:
	free(res);
	return NULL;

};	/* BLT_stubs_tie */

int BLT_stubs_untie(ggiBlt_t *blt) {
#warning TODO
  return -1;
};	/* BLT_stubs_untie */


